import extra_geom
from karabo.bound import KARABO_CLASSINFO, OVERWRITE_ELEMENT, Hash

from ._version import version as deviceVersion
from .manual_geometry_base import ManualModulesGeometryBase


@KARABO_CLASSINFO("ManualJungfrauGeometry", deviceVersion)
class ManualJungfrauGeometry(ManualModulesGeometryBase):
    geometry_class = extra_geom.JUNGFRAUGeometry

    @staticmethod
    def expectedParameters(expected):
        # TODO: come up with some sweet defaults (this is two modules from docs 4M)
        (
            OVERWRITE_ELEMENT(expected)
            .key("modules")
            .setNewDefaultValue(
                [
                    Hash(
                        "posX", 95, "posY", 564, "orientationX", -1, "orientationY", -1
                    ),
                    Hash(
                        "posX", 95, "posY", 17, "orientationX", -1, "orientationY", -1
                    ),
                ]
            )
        )
